| Face Engine SDK 5.2.0 A face detection, recognition and tracking engine.

- Main Page
- Modules
- Namespaces
- Classes
- Files

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Classes | Macros | Functions
SDK core interfaces

Common interfaces and macros shared across all SDK objects. More...

## Classes
struct | fsdk::IFaceEngine
| Root LUNA SDK object interface. More...
struct | fsdk::IFaceEngineMobile
| Root LUNA SDK object interface. More...
struct | fsdk::IArchive
| Archive interface. More...
struct | fsdk::ISerializableObject
| Serializable object interface. More...
struct | fsdk::ErrorTraits< ISerializableObject::Error >
| Specialized for ISerializableObject::SerializationError. More...
struct | fsdk::IDataStorageObject
| Data storage object interface helper. More...
struct | fsdk::IRefCounted
| Base strong reference counted object interface. More...
struct | fsdk::ISettingsProvider
| SDK settings provider interface. More...
struct | fsdk::ErrorTraits< ISettingsProvider::Error >
| Specialized for ISettingsProvider::ParseError. More...

## Macros
#define | ALIGN_UP(value, align)
#define | ALIGNED(x) __attribute__ ((aligned(x)))
#define | RESTRICT __restrict__
#define | FORCE_INLINE inline __attribute__ ((always_inline))
#define | DECLARE_SMARTPTR(X) struct X; using X##Ptr = fsdk::Ref<X>
| Smart ptr declaration helper macro.
#define | STRINGIFY2(x) #x
| Stringification helper macro.
#define | STRINGIFY(x) STRINGIFY2(x)
| Stringifies it's argument.

## Functions
FSDK_API Result< FSDKError > | fsdk::activateLicense (ILicense *license, const char *configPath) noexcept
| Makes License activation with some platform specific manner. Network connection is required. More...
FSDK_API Result< FSDKError > | fsdk::activateLicense (ILicense *license, fsdk::ISettingsProvider *settings) noexcept
| Makes License activation with some platform specific manner. Network connection is required. More...
FSDK_API ResultValue < FSDKError, IFaceEnginePtr > | fsdk::createFaceEngine (const char *dataPath=nullptr, const char *configPath=nullptr, const char *runtimePath=nullptr) noexcept
| Create the LUNA SDK root object. More...
FSDK_API ResultValue < FSDKError, ISettingsProviderPtr > | fsdk::createSettingsProvider (const char *path) noexcept
| Create a settings provider. More...
virtual ResultValue< FSDKError, IDetectorPtr > | fsdk::IFaceEngineMobile::createDetector () noexcept=0
| Creates a detector of given type. More...
virtual ResultValue< FSDKError, IHeadPoseEstimatorPtr > | fsdk::IFaceEngineMobile::createHeadPoseEstimator () noexcept=0
| Creates Head pose estimator. More...
virtual ResultValue< FSDKError, IAGSEstimatorPtr > | fsdk::IFaceEngineMobile::createAGSEstimator () noexcept=0
| Creates AGS estimator. More...
virtual ResultValue< FSDKError, IEyeEstimatorPtr > | fsdk::IFaceEngineMobile::createEyeEstimator () noexcept=0
| Creates Eye estimator. More...
virtual ResultValue< FSDKError, IBestShotQualityEstimatorPtr > | fsdk::IFaceEngineMobile::createBestShotQualityEstimator () noexcept=0
| Creates BestShotQuality estimator. More...
virtual ResultValue< FSDKError, IDescriptorPtr > | fsdk::IFaceEngineMobile::createDescriptor (uint32_t version=0) noexcept=0
| Creates Descriptor. More...
virtual ResultValue< FSDKError, IDescriptorPtr > | fsdk::IFaceEngineMobile::createDescriptor (IArchive *archive, uint32_t flags=0) noexcept=0
| Creates and loads Descriptor from Archive. More...
virtual ResultValue< FSDKError, IDescriptorBatchPtr > | fsdk::IFaceEngineMobile::createDescriptorBatch (int32_t size, uint32_t version=0) noexcept=0
| Creates Batch of descriptors. More...
virtual ResultValue< FSDKError, IDescriptorExtractorPtr > | fsdk::IFaceEngineMobile::createExtractor (uint32_t version=0) noexcept=0
| Creates descriptor extractor. More...
virtual ResultValue< FSDKError, IDescriptorMatcherPtr > | fsdk::IFaceEngineMobile::createMatcher (uint32_t version=0) noexcept=0
| Creates descriptor matcher. More...
virtual ResultValue< FSDKError, IWarperPtr > | fsdk::IFaceEngineMobile::createWarper () noexcept=0
| Creates warper. More...
virtual FaceEngineEdition | fsdk::IFaceEngineMobile::getFaceEngineEdition () const noexcept=0
| Get LUNA SDK ditribution edition. More...
virtual void | fsdk::IFaceEngineMobile::setDataDirectory (const char *path) noexcept=0
| Sets data directory. More...
virtual const char * | fsdk::IFaceEngineMobile::getDataDirectory () const noexcept=0
| Gets data directory. More...
virtual void | fsdk::IFaceEngineMobile::setSettingsProvider (ISettingsProvider *provider) noexcept=0
| Sets settings provider. More...
virtual void | fsdk::IFaceEngineMobile::setRuntimeSettingsProvider (ISettingsProvider *provider) noexcept=0
| Sets runtime settings provider. More...
virtual ISettingsProvider * | fsdk::IFaceEngineMobile::getSettingsProvider () const noexcept=0
| Gets settings provider. More...
virtual ISettingsProvider * | fsdk::IFaceEngineMobile::getRuntimeSettingsProvider () const noexcept=0
| Gets runtime settings provider. More...
virtual ILicense * | fsdk::IFaceEngineMobile::getLicense () const noexcept=0
| Get current License object, which was set for FaceEngine object. More...
FSDK_API ResultValue < FSDKError, IFaceEngineMobilePtr > | fsdk::createFaceEngineMobile (const char *dataPath=nullptr, const char *configPath=nullptr, const char *runtimePath=nullptr) noexcept
| Create the LUNA SDK root object. More...
bool | fsdk::ISettingsProvider::Value::setString (const char *string) noexcept
| Set a string value. More...
| fsdk::ISettingsProvider::Value::Value (Value &&other)
Value & | fsdk::ISettingsProvider::Value::operator= (Value &&other)
void | fsdk::ISettingsProvider::Value::swap (Value &first, Value &second)
bool | fsdk::ISettingsProvider::Value::getString (char *string) const noexcept
| Get a string value. More...
void | fsdk::ISettingsProvider::Value::setRect (const Rect &rect) noexcept
| Set a rect value. More...
bool | fsdk::ISettingsProvider::Value::getRect (Rect *rect) const noexcept
| Get a rect value. More...
void | fsdk::ISettingsProvider::Value::setSize (const Size &size) noexcept
| Set a size value. More...
bool | fsdk::ISettingsProvider::Value::getSize (Size *size) const noexcept
| Get a size value. More...
void | fsdk::ISettingsProvider::Value::setPoint2i (const Point2i &point) noexcept
| Set a Point2i value. More...
bool | fsdk::ISettingsProvider::Value::getPoint2i (Point2i *point) const noexcept
| Get a Point2i value. More...
void | fsdk::ISettingsProvider::Value::setPoint2f (const Point2f &point) noexcept
| Set a setPoint2f value. More...
bool | fsdk::ISettingsProvider::Value::getPoint2f (Point2f *point) const noexcept
| Get a Point2f value. More...
void | fsdk::ISettingsProvider::Value::setBool (bool x) noexcept
| Set a bool value. More...
bool | fsdk::ISettingsProvider::Value::getBool (bool *x) const noexcept
| Get a bool value. More...
void | fsdk::ISettingsProvider::Value::setInt (int x) noexcept
| Set an int value. More...
bool | fsdk::ISettingsProvider::Value::getInt (int *x) const noexcept
| Get an int value. More...
void | fsdk::ISettingsProvider::Value::setInt (int x, int y) noexcept
| Set a 2d int value. More...
bool | fsdk::ISettingsProvider::Value::getInt (int *x, int *y) const noexcept
| Get a 2d int value. More...
void | fsdk::ISettingsProvider::Value::setInt (int x, int y, int z) noexcept
| Set a 3d int value. More...
bool | fsdk::ISettingsProvider::Value::getInt (int *x, int *y, int *z) const noexcept
| Get a 3d int value. More...
void | fsdk::ISettingsProvider::Value::setInt (int x, int y, int z, int w) noexcept
| Set a 4d int value. More...
bool | fsdk::ISettingsProvider::Value::getInt (int *x, int *y, int *z, int *w) const noexcept
| Get a 4d int value. More...
void | fsdk::ISettingsProvider::Value::setFloat (float x) noexcept
| Set a float value. More...
bool | fsdk::ISettingsProvider::Value::getFloat (float *x) const noexcept
| Get a float value. More...
void | fsdk::ISettingsProvider::Value::setFloat (float x, float y) noexcept
| Set a 2d float value. More...
bool | fsdk::ISettingsProvider::Value::getFloat (float *x, float *y) const noexcept
| Get a 2d float value. More...
void | fsdk::ISettingsProvider::Value::setFloat (float x, float y, float z) noexcept
| Set a 3d float value. More...
bool | fsdk::ISettingsProvider::Value::getFloat (float *x, float *y, float *z) const noexcept
| Get a 3d float value. More...
void | fsdk::ISettingsProvider::Value::setFloat (float x, float y, float z, float w) noexcept
| Set a 4d float value. More...
bool | fsdk::ISettingsProvider::Value::getFloat (float *x, float *y, float *z, float *w) const noexcept
| Get a 4d float value. More...
float | fsdk::ISettingsProvider::Value::asFloat (float defaultValue=0.f) const noexcept
| Safely get a float. More...
Point2f | fsdk::ISettingsProvider::Value::asPoint2f (const Point2f &defaultValue=Point2f()) const noexcept
| Safely get a Point2f. More...
bool | fsdk::ISettingsProvider::Value::asBool (bool defaultValue=false) const noexcept
| Safely get a boolean. More...
int | fsdk::ISettingsProvider::Value::asInt (int defaultValue=0) const noexcept
| Safely get an integer. More...
Size | fsdk::ISettingsProvider::Value::asSize (const Size &defaultValue=Size()) const noexcept
| Safely get a Size. More...
Point2i | fsdk::ISettingsProvider::Value::asPoint2i (const Point2i &defaultValue=Point2i()) const noexcept
| Safely get a Point2i. More...
Rect | fsdk::ISettingsProvider::Value::asRect (const Rect &defaultValue=Rect()) const noexcept
| Safely get a Rect. More...
const char * | fsdk::ISettingsProvider::Value::asString (const char *defaultValue="") const noexcept
| Safely get a string. More...
| fsdk::ISettingsProvider::Key::Key () noexcept
| Initialize an empty key.
| fsdk::ISettingsProvider::Key::Key (const char *section, const char *parameter) noexcept
| Initialize a key. More...
void | fsdk::ISettingsProvider::Key::setSection (const char *section) noexcept
| Set section name. More...
void | fsdk::ISettingsProvider::Key::setParameter (const char *parameter) noexcept
| Set parameter name. More...
bool | fsdk::ISettingsProvider::Key::operator< (const ISettingsProvider::Key &other) const noexcept
| Operator `Less`. More...
| fsdk::ISettingsProvider::Desc::Desc () noexcept
| Initialize an empty description.
| fsdk::ISettingsProvider::Desc::Desc (const char *desc) noexcept
| Initialize a description. More...
void | fsdk::ISettingsProvider::Desc::setDesc (const char *desc) noexcept
| Set description text. More...
| fsdk::ISettingsProvider::Entry::Entry (const Desc &desc, Value &&value) noexcept
| Initialize an entry. More...
void | fsdk::ISettingsProvider::Entry::setDesc (const Desc &desc) noexcept
| Set description. More...
void | fsdk::ISettingsProvider::Entry::setValue (Value &&value) noexcept
| Set value. More...

## Detailed Description

Common interfaces and macros shared across all SDK objects.

## Macro Definition Documentation

#define ALIGN_UP | ( |  | value,
|  |  | align
| ) |  |

Value:
(((value) & (align-1)) ? \
(((value) + (align-1)) & ~(align-1)) : \
(value))

## Function Documentation

fsdk::ISettingsProvider::Desc::Desc | ( | const char * | desc | ) |
| inline noexcept

Initialize a description.

Parameters

  desc | description text.

fsdk::ISettingsProvider::Entry::Entry | ( | const Desc & | desc,
|  | Value && | value
| ) |  |
| inline noexcept

Initialize an entry.

Parameters

  desc | description.
  value | value.

fsdk::ISettingsProvider::Key::Key | ( | const char * | section,
|  | const char * | parameter
| ) |  |
| inline noexcept

Initialize a key.

Parameters

  section | section name.
  parameter | parameter name.

FSDK_API Result< FSDKError > fsdk::activateLicense | ( | ILicense * | license,
|  | const char * | configPath
| ) |  |
| noexcept

Makes License activation with some platform specific manner. Network connection is required.

Parameters

  license | pointer to the license object which should be activated
  configPath | path to license.conf file with licensing settings.

Returns
  true if license was successfully activated.

FSDK_API Result<FSDKError> fsdk::activateLicense | ( | ILicense * | license,
|  | fsdk::ISettingsProvider * | settings
| ) |  |
| noexcept

Makes License activation with some platform specific manner. Network connection is required.

Parameters

  license | pointer to the license object which should be activated
  provider | settings provider.

Returns
  true if license was successfully activated.

bool ISettingsProvider::Value::asBool | ( | bool | defaultValue = `false` | ) | const
| inline noexcept

Safely get a boolean.

If actual value type is convertible to bool, the value is returned; if not a fallback value is returned.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

float ISettingsProvider::Value::asFloat | ( | float | defaultValue = `0.f` | ) | const
| inline noexcept

Safely get a float.

If actual value type is float, the value is returned; if not a fallback value is returned.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

int ISettingsProvider::Value::asInt | ( | int | defaultValue = `0` | ) | const
| inline noexcept

Safely get an integer.

If actual value type is Int, the value is returned; if not a fallback value is returned.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

Point2f ISettingsProvider::Value::asPoint2f | ( | const Point2f & | defaultValue = `Point2f()` | ) | const
| inline noexcept

Safely get a Point2f.

If actual value type is convertible to Point2f, the value is returned; if not a fallback value is returned.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

Point2i ISettingsProvider::Value::asPoint2i | ( | const Point2i & | defaultValue = `Point2i()` | ) | const
| inline noexcept

Safely get a Point2i.

If actual value type is convertible to Point2i, the value is returned; if not a fallback value is returned.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

Rect ISettingsProvider::Value::asRect | ( | const Rect & | defaultValue = `Rect()` | ) | const
| inline noexcept

Safely get a Rect.

If actual value type is convertible to Rect, the value is returned; if not a fallback value is returned.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

Size ISettingsProvider::Value::asSize | ( | const Size & | defaultValue = `Size()` | ) | const
| inline noexcept

Safely get a Size.

If actual value type is convertible to Size, the value is returned; if not a fallback value is returned.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

const char * ISettingsProvider::Value::asString | ( | const char * | defaultValue = `""` | ) | const
| inline noexcept

Safely get a string.

If actual value type is String, the value is returned; if not a fallback value is returned.

Note
  Doesn't allocate or copy memory.

Parameters

  defaultValue | fallback value (optional).

Returns
  value.

virtual ResultValue<FSDKError, IAGSEstimatorPtr> fsdk::IFaceEngineMobile::createAGSEstimator | ( |  | ) |
| pure virtual noexcept

Creates AGS estimator.

Returns
  Error code;

See Also
  FSDKError and AGS estimator if succeeded, null if failed.

virtual ResultValue<FSDKError, IBestShotQualityEstimatorPtr> fsdk::IFaceEngineMobile::createBestShotQualityEstimator | ( |  | ) |
| pure virtual noexcept

Creates BestShotQuality estimator.

Returns
  Error code;

See Also
  FSDKError and BestShotQuality estimator if succeed, null if failed.

virtual ResultValue<FSDKError, IDescriptorPtr> fsdk::IFaceEngineMobile::createDescriptor | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates Descriptor.

face descriptor will created by default, to create human descriptor pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

See Also
  fsdk::DescriptorVersion

Returns
  Error code;

See Also
  FSDKError and Descriptor if succeed, null if failed.

virtual ResultValue<FSDKError, IDescriptorPtr> fsdk::IFaceEngineMobile::createDescriptor | ( | IArchive * | archive,
|  | uint32_t | flags = `0`
| ) |  |
| pure virtual noexcept

Creates and loads Descriptor from Archive.

Parameters

  archive | Archive with descriptor.
  flags | Archive flag.

Returns
  Error code;

See Also
  FSDKError and Descriptor if succeed, null if failed.

virtual ResultValue<FSDKError, IDescriptorBatchPtr> fsdk::IFaceEngineMobile::createDescriptorBatch | ( | int32_t | size,
|  | uint32_t | version = `0`
| ) |  |
| pure virtual noexcept

Creates Batch of descriptors.

face descriptor batch will be created by default, to create human descriptor batch you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

See Also
  fsdk::DescriptorVersion

Parameters

  [in] | size | - amount of descriptors in batch.
  [in] | version | - descriptor version in batch. If 0 - use dafault version from config.

Returns
  Error code;

See Also
  FSDKError and Batch if succeed, null if failed.

virtual ResultValue<FSDKError, IDetectorPtr> fsdk::IFaceEngineMobile::createDetector | ( |  | ) |
| pure virtual noexcept

Creates a detector of given type.

Returns
  Error code;

See Also
  FSDKError and detector object if succeeded, null if failed.

virtual ResultValue<FSDKError, IDescriptorExtractorPtr> fsdk::IFaceEngineMobile::createExtractor | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates descriptor extractor.

face descriptor extractor will created by default, to create human descriptor extractor descriptor you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

See Also
  fsdk::DescriptorVersion

Returns
  Error code;

See Also
  FSDKError and Descriptor extractor if succeed, null if failed.

virtual ResultValue<FSDKError, IEyeEstimatorPtr> fsdk::IFaceEngineMobile::createEyeEstimator | ( |  | ) |
| pure virtual noexcept

Creates Eye estimator.

Returns
  Error code;

See Also
  FSDKError and Eye estimator if succeed, null if failed.

FSDK_API ResultValue<FSDKError, IFaceEnginePtr> fsdk::createFaceEngine | ( | const char * | dataPath = `nullptr`,
|  | const char * | configPath = `nullptr`,
|  | const char * | runtimePath = `nullptr`
| ) |  |
| noexcept

Create the LUNA SDK root object.

Parameters

  [in] | dataPath | [optional] path to folder with FSDK data. Default: ./data (on windows), /opt/visionlabs/data (on linux)
  [in] | configPath | [optional] path to faceengine.conf file. Default: <dataPath>/faceengine.conf
  [in] | runtimePath | [optional] path to runtime.conf file. Default: <dataPath>/runtime.conf

Returns
  ResultValue with error code and IFaceEnginePtr instance.

See Also
  ResultValue, FSDKError, IFaceEnginePtr

FSDK_API ResultValue<FSDKError, IFaceEngineMobilePtr> fsdk::createFaceEngineMobile | ( | const char * | dataPath = `nullptr`,
|  | const char * | configPath = `nullptr`,
|  | const char * | runtimePath = `nullptr`
| ) |  |
| noexcept

Create the LUNA SDK root object.

Parameters

  [in] | dataPath | [optional] path to folder with FSDK data. Default: ./data (on windows), /opt/visionlabs/data (on linux)
  [in] | configPath | [optional] path to faceengine.conf file. Default: <dataPath>/faceengine.cong
  [in] | runtimePath | [optional] path to runtime.conf file. Default: <dataPath>/runtime.cong

Returns
  Error code;

See Also
  FSDKError and face engine object if succeeded, null if failed.

virtual ResultValue<FSDKError, IHeadPoseEstimatorPtr> fsdk::IFaceEngineMobile::createHeadPoseEstimator | ( |  | ) |
| pure virtual noexcept

Creates Head pose estimator.

Returns
  Error code;

See Also
  FSDKError and Head pose estimator if succeeded, null if failed.

virtual ResultValue<FSDKError, IDescriptorMatcherPtr> fsdk::IFaceEngineMobile::createMatcher | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates descriptor matcher.

face descriptor matcher will created by default, to create human descriptor matcher you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

See Also
  fsdk::DescriptorVersion

Returns
  Error code;

See Also
  FSDKError and Descriptor matcher if succeed, null if failed.

FSDK_API fsdk::ResultValue< fsdk::FSDKError, fsdk::ISettingsProviderPtr > fsdk::createSettingsProvider | ( | const char * | path | ) |
| noexcept

Create a settings provider.

Parameters

  [in] | path | configuration file path.

Returns
  Error code;

See Also
  FSDKError and settings provider object if succeeded, null if failed.

Parameters

  [in] | path | configuration file path.

Returns
  settings provider object if succeeded, null if failed.

virtual ResultValue<FSDKError, IWarperPtr> fsdk::IFaceEngineMobile::createWarper | ( |  | ) |
| pure virtual noexcept

Creates warper.

Returns
  Warper if succeed, null if failed.

bool ISettingsProvider::Value::getBool | ( | bool * | x | ) | const
| inline noexcept

Get a bool value.

Parameters

  [out] | x | the value.

Note
  function fails if actual value type is not convertible to bool; in this case `x` isn't modified.

Returns
  true if succeeded; false otherwise.

virtual const char* fsdk::IFaceEngineMobile::getDataDirectory | ( |  | ) | const
| pure virtual noexcept

Gets data directory.

By default is set to "./data".

Returns
  path to data directory.

virtual FaceEngineEdition fsdk::IFaceEngineMobile::getFaceEngineEdition | ( |  | ) | const
| pure virtual noexcept

Get LUNA SDK ditribution edition.

Returns
  Edition of LUNA SDK instance. Posible values:
  - CompleteEdition - full edition with all function.
  - FrontEndEdition - short edition with excluded descriptor functions. Extractor, matcher, descriptor, batch and index cannot be created.

bool fsdk::ISettingsProvider::Value::getFloat | ( | float * | x | ) | const
| inline noexcept

Get a float value.

Parameters

  [out] | x | the value.

Note
  function fails if actual value type is not a float; in this case 'x' isn't modified.

Returns
  true if succeeded; false otherwise.

bool fsdk::ISettingsProvider::Value::getFloat | ( | float * | x,
|  | float * | y
| ) |  | const
| inline noexcept

Get a 2d float value.

Parameters

  [out] | x | 1st value.
  [out] | y | 2nd value.

Note
  function fails if actual value type is not a 2d float; in this case output parameters aren't modified.

Returns
  true if succeeded; false otherwise.

bool fsdk::ISettingsProvider::Value::getFloat | ( | float * | x,
|  | float * | y,
|  | float * | z
| ) |  | const
| inline noexcept

Get a 3d float value.

Parameters

  [out] | x | 1st value.
  [out] | y | 2nd value.
  [out] | z | 3rd value.

Note
  function fails if actual value type is not a 3d float; in this case output parameters aren't modified.

Returns
  true if succeeded; false otherwise.

bool fsdk::ISettingsProvider::Value::getFloat | ( | float * | x,
|  | float * | y,
|  | float * | z,
|  | float * | w
| ) |  | const
| inline noexcept

Get a 4d float value.

Parameters

  [out] | x | 1st value.
  [out] | y | 2nd value.
  [out] | z | 3rd value.
  [out] | w | 4th value.

Note
  function fails if actual value type is not a 4d float; in this case output parameters aren't modified.

Returns
  true if succeeded; false otherwise.

bool fsdk::ISettingsProvider::Value::getInt | ( | int * | x | ) | const
| inline noexcept

Get an int value.

Parameters

  [out] | x | the value.

Note
  function fails if actual value type is not an int; in this case `x` isn't modified.

Returns
  true if succeeded; false otherwise.

bool fsdk::ISettingsProvider::Value::getInt | ( | int * | x,
|  | int * | y
| ) |  | const
| inline noexcept

Get a 2d int value.

Parameters

  [out] | x | 1st value.
  [out] | y | 2nd value.

Note
  function fails if actual value type is not a 2d int; in this case output parameters aren't modified.

Returns
  true if succeeded; false otherwise.

bool fsdk::ISettingsProvider::Value::getInt | ( | int * | x,
|  | int * | y,
|  | int * | z
| ) |  | const
| inline noexcept

Get a 3d int value.

Parameters

  [out] | x | 1st value.
  [out] | y | 2nd value.
  [out] | z | 3rd value.

Note
  function fails if actual value type is not a 3d int; in this case output parameters aren't modified.

Returns
  true if succeeded; false otherwise.

bool fsdk::ISettingsProvider::Value::getInt | ( | int * | x,
|  | int * | y,
|  | int * | z,
|  | int * | w
| ) |  | const
| inline noexcept

Get a 4d int value.

Parameters

  [out] | x | 1st value.
  [out] | y | 2nd value.
  [out] | z | 3rd value.
  [out] | w | 4th value.

Note
  function fails if actual value type is not a 4d int; in this case output parameters aren't modified.

Returns
  true if succeeded; false otherwise.

virtual ILicense* fsdk::IFaceEngineMobile::getLicense | ( |  | ) | const
| pure virtual noexcept

Get current License object, which was set for FaceEngine object.

Returns
  pointer to current license object, nullptr if no any license was set to.

bool ISettingsProvider::Value::getPoint2f | ( | Point2f * | point | ) | const
| inline noexcept

Get a Point2f value.

Parameters

  [out] | point | the value.

Note
  function fails if actual value type is not convertible to Point2f; in this case `point` isn't modified.

Returns
  true if succeeded; false otherwise.

bool ISettingsProvider::Value::getPoint2i | ( | Point2i * | point | ) | const
| inline noexcept

Get a Point2i value.

Parameters

  [out] | point | the value.

Note
  function fails if actual value type is not convertible to Point2i; in this case `point` isn't modified.

Returns
  true if succeeded; false otherwise.

bool ISettingsProvider::Value::getRect | ( | Rect * | rect | ) | const
| inline noexcept

Get a rect value.

Parameters

  [out] | rect | the value.

Note
  function fails if actual value type is not convertible to rect; in this case `rect` isn't modified.

Returns
  true if succeeded; false otherwise.

virtual ISettingsProvider* fsdk::IFaceEngineMobile::getRuntimeSettingsProvider | ( |  | ) | const
| pure virtual noexcept

Gets runtime settings provider.

Returns
  runtime settings provider.

virtual ISettingsProvider* fsdk::IFaceEngineMobile::getSettingsProvider | ( |  | ) | const
| pure virtual noexcept

Gets settings provider.

Returns
  settings provider.

bool ISettingsProvider::Value::getSize | ( | Size * | size | ) | const
| inline noexcept

Get a size value.

Parameters

  [out] | size | the value.

Note
  function fails if actual value type is not convertible to size; in this case `size` isn't modified.

Returns
  true if succeeded; false otherwise.

bool ISettingsProvider::Value::getString | ( | char * | string | ) | const
| inline noexcept

Get a string value.

Parameters

  [out] | string | the value.

Note
  function fails if actual value type is not string; in this case `string` isn't modified.

Returns
  true if succeeded; false otherwise.

bool ISettingsProvider::Key::operator< | ( | const ISettingsProvider::Key & | other | ) | const
| inline noexcept

Operator `Less`.

Parameters

  other | other key.

Returns
  comparison result.

void ISettingsProvider::Value::setBool | ( | bool | x | ) |
| inline noexcept

Set a bool value.

Parameters

  x | the value.

virtual void fsdk::IFaceEngineMobile::setDataDirectory | ( | const char * | path | ) |
| pure virtual noexcept

Sets data directory.

Parameters

  [in] | path | path to data directory.

void ISettingsProvider::Desc::setDesc | ( | const char * | desc | ) |
| inline noexcept

Set description text.

Parameters

  desc | description text.

void ISettingsProvider::Entry::setDesc | ( | const Desc & | desc | ) |
| inline noexcept

Set description.

Parameters

  desc | description.

void fsdk::ISettingsProvider::Value::setFloat | ( | float | x | ) |
| inline noexcept

Set a float value.

Parameters

  x | the value.

void fsdk::ISettingsProvider::Value::setFloat | ( | float | x,
|  | float | y
| ) |  |
| inline noexcept

Set a 2d float value.

Parameters

  x | 1st value.
  y | 2nd value.

void fsdk::ISettingsProvider::Value::setFloat | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |
| inline noexcept

Set a 3d float value.

Parameters

  x | 1st value.
  y | 2nd value.
  z | 3rd value.

void fsdk::ISettingsProvider::Value::setFloat | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | w
| ) |  |
| inline noexcept

Set a 4d float value.

Parameters

  x | 1st value.
  y | 2nd value.
  z | 3rd value.
  w | 4th value.

void fsdk::ISettingsProvider::Value::setInt | ( | int | x | ) |
| inline noexcept

Set an int value.

Parameters

  x | the value.

void fsdk::ISettingsProvider::Value::setInt | ( | int | x,
|  | int | y
| ) |  |
| inline noexcept

Set a 2d int value.

Parameters

  x | 1st value.
  y | 2nd value.

void fsdk::ISettingsProvider::Value::setInt | ( | int | x,
|  | int | y,
|  | int | z
| ) |  |
| inline noexcept

Set a 3d int value.

Parameters

  x | 1st value.
  y | 2nd value.
  z | 3rd value.

void fsdk::ISettingsProvider::Value::setInt | ( | int | x,
|  | int | y,
|  | int | z,
|  | int | w
| ) |  |
| inline noexcept

Set a 4d int value.

Parameters

  x | 1st value.
  y | 2nd value.
  z | 3rd value.
  w | 4th value.

void ISettingsProvider::Key::setParameter | ( | const char * | parameter | ) |
| inline noexcept

Set parameter name.

Parameters

  parameter | parameter name.

void ISettingsProvider::Value::setPoint2f | ( | const Point2f & | point | ) |
| inline noexcept

Set a setPoint2f value.

Parameters

  point | the value.

void ISettingsProvider::Value::setPoint2i | ( | const Point2i & | point | ) |
| inline noexcept

Set a Point2i value.

Parameters

  point | the value.

void ISettingsProvider::Value::setRect | ( | const Rect & | rect | ) |
| inline noexcept

Set a rect value.

Parameters

  rect | the value.

virtual void fsdk::IFaceEngineMobile::setRuntimeSettingsProvider | ( | ISettingsProvider * | provider | ) |
| pure virtual noexcept

Sets runtime settings provider.

Parameters

  [in] | provider | runtime settings provider.

void ISettingsProvider::Key::setSection | ( | const char * | section | ) |
| inline noexcept

Set section name.

Parameters

  section | section name.

virtual void fsdk::IFaceEngineMobile::setSettingsProvider | ( | ISettingsProvider * | provider | ) |
| pure virtual noexcept

Sets settings provider.

Parameters

  [in] | provider | settings provider.

void ISettingsProvider::Value::setSize | ( | const Size & | size | ) |
| inline noexcept

Set a size value.

Parameters

  size | the value.

bool ISettingsProvider::Value::setString | ( | const char * | string | ) |
| inline noexcept

Set a string value.

Parameters

  string | the value.

void ISettingsProvider::Entry::setValue | ( | Value && | value | ) |
| inline noexcept

Set value.

Parameters

  value | value.